var gGadgetMode = (window.System !== undefined); //if we're in gadget mode or dev. mode
var units;
var main;

function Settings_onLoad() {
  
  if (gGadgetMode) {
    //FIXME only part needed in this block
    main = System.Gadget.document.parentWindow;
    $('logo').onclick = main.linkTo('http://www.wunderground.com');
  } else {
    main = window;
    main.linkTo = function (str) { window.href = str;};
    main.prefs = new Preferences();
  }
  
  //load units box
	Units_makeUnitSelector();
  Settings_loadZip();
  
  if (gGadgetMode) {    
    System.Gadget.onSettingsClosing  = function(event) { 
      if (event.closeAction == event.Action.commit) { 
        if ($('zip').value != main.prefs.get("query") || done_button.onclick == Gadget_useDefaultAirport) {
          return done_button.onclick();
        }
      }
    };
  }
  
  $('searchButton').value                   = main.getLocalizedString('Search');
  $('unitSelectorLabel').innerHTML          = main.getLocalizedString('Units') + ":";     
  $('zipLabel').innerHTML                   = main.getLocalizedString('City, State or ZIP Code') + ":";
  $('locationNotFound').innerHTML           = main.getLocalizedString("Couldn't find city, be more specific");
  $('connectionProblem').innerHTML          = main.getLocalizedString("Please check your internet connection");
  $('vagueLocationLabel').innerHTML         = main.getLocalizedString("Please refine your search") + ":";
  $('localWxStationLabel').innerHTML        = main.getLocalizedString("Select your local weather station") + ":";

}

function Settings_loadZip() {
  $('zip').value = main.prefs.get("query");
}

function Settings_showOnly(id) {
	var elements = ["vagueLocationLabel","localWxStationLabel","vagueLocationSelect","localWxStationSelect","locationNotFound","connectionProblem", "XMLParseError"];
	
	if (typeof(id) == "string" || id == null)
		for(var i = 0; i < elements.length; i++) {
			$(elements[i]).style.display = elements[i] == id ? "" : "none";
		}
	else
	for(var i = 0; i < elements.length; i++) {
		$(elements[i]).style.display = "none";// hide(elements[i]);
		for (var j = 0; j < id.length; j++)
      if (elements[i] == id[j]) $(elements[i]).style.display = "";// show(elements[i]); 
	}		
}

function Gadget_keypressSubmitLocation(evt) {
  var returnCode = true;
	if ((evt.charCode == 13 || evt.charCode == 3) || (evt.keyCode != null && evt.keyCode == 13))  {
		Gadget_submitLocation();
		returnCode = false;
	} 
	return returnCode;
}
function Gadget_useDefaultAirport() {
  // main.Gadget_launchLocalStns(main.Forecast_forecastData);
  main.CurCond_retrieve('airport',false,main.setCurConds, main.CurCond_errorLoading);
  done_button.reset();
}
function Gadget_submitLocation() {

  //If we have a connection problem

	query = $('zip').value;
	main.prefs.set("query",query);
	
	Query_hadVagueLocation = false;
	Query_retrieve(query,null,Query_errorLoading);
  
}
function makeSelectBox(id,elements,eventListenerCallback) {
	var ele = document.getElementById(id);
	var option; var select;

	select = document.createElement('select');
	select.setAttribute("id",id);
	
	var optgroup = select;
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].optgroup) {
		  if (optgroup != select) {
		    select.appendChild(optgroup);
		  }
		  optgroup = document.createElement('optgroup');
		  optgroup.setAttribute("label",elements[i].name);
		  continue;
	  }
		  
		option = document.createElement('option');
		option.setAttribute('value',elements[i].value);
		if (elements[i].disabled) {option.setAttribute('disabled','disabled');}
		if (elements[i].selected) {option.setAttribute('selected','selected');}
		option.innerHTML = elements[i].name;
		optgroup.appendChild(option);
	}
	if (optgroup != select) {
	  select.appendChild(optgroup);
	}

	ele.parentNode.replaceChild(select,ele);

	ele = document.getElementById(id);
	ele.onchange = eventListenerCallback;
}